﻿Type=Activity
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Connector As IPcomm
	Dim downloadtimer As Timer
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private Panel1 As Panel
	Private txtAdres As EditText
	Private txtPass As EditText
	Private txtPoort As EditText
	Private cmdGet As Button
	Private Spinner1 As Spinner
	Private MapSettings As Map
	Private cmdSave As Button
	
	Private cmdDelete As Button
	Private Tekst As String
	Private Groep As Byte
	Private Unit As Byte
	Private DownloadAdres As Int
	Private ProgressBar1 As ProgressBar
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	  downloadtimer.Initialize("downloadtimer",2000)
  downloadtimer.Enabled=False

	If FirstTime Then
	  Connector.Initialize(Me,"Connector",8901)
	End If
	Activity.LoadLayout("Settings")
	If File.Exists(File.DirInternal,"Settings.txt") Then
		MapSettings=File.ReadMap(File.DirInternal,"Settings.txt")
		If MapSettings.Get("Systems")>0 Then
			For i=1 To MapSettings.Get("Systems")
		  		Spinner1.Add(MapSettings.Get("Name"&i))
			Next
			txtAdres.Text=MapSettings.Get("IP1")
			txtPoort.Text=MapSettings.Get("Port1")
			txtPass.Text=MapSettings.Get("Pass1")
		End If
	Else
		MapSettings.Initialize
	End If
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub cmdGet_Click
	Connector.Connect(txtAdres.Text,txtPoort.Text,txtPass.Text)
End Sub

Sub Connector_ConnectionEstablished (Version As String, Name As String)
	
	If Spinner1.IndexOf(Name)<0 Then
		Spinner1.Add(Name)
		Spinner1.SelectedIndex=Spinner1.Size-1
	End If
	MapSettings.Put("Systems",Spinner1.Size)
	MapSettings.Put("Name"&(Spinner1.SelectedIndex+1),Name)
	MapSettings.Put("IP"&(Spinner1.SelectedIndex+1),txtAdres.Text)
	MapSettings.Put("Port"&(Spinner1.SelectedIndex+1),txtPoort.Text)
	MapSettings.Put("Pass"&(Spinner1.SelectedIndex+1),txtPass.Text)
	Groep=0
	Unit=1
	ReceiveNext
	
End Sub

Sub Connector_Download (Adres As Int, data() As Byte)
 If downloadtimer.Enabled=True Then
 If Adres=DownloadAdres Then
 	ProgressBar1.Progress=(Bit.And(Bit.Or(Groep*16,Unit),255)/255*100)
  	Tekst=BytesToString(data,0,data.Length-1,"UTF-8")
	
    MapSettings.Put("S"&(Spinner1.SelectedIndex+1)&"G"&Groep&"U"&Unit,Tekst)
	MapSettings.Put("S"&(Spinner1.SelectedIndex+1)&"G"&Groep&"U"&Unit&"T",data(data.Length-1))
 	Unit=Unit+1
	If Unit>15 Then 
  		Groep=Groep+1
  		Unit=1
	End If
	If Groep>15 Then
		downloadtimer.Enabled=False
		Msgbox("Voltooid","Download")
  		Connector.Disconnect
	Else
  		ReceiveNext
	End If
Else
  	ReceiveNext
End If
End If
End Sub

Sub Connector_ConnectionTimeOut
	Msgbox("Controleer Adres, Poort en Wachtwoord","Verbinden lukt niet!")
End Sub
Sub cmdSave_Click
	File.WriteMap(File.DirInternal,"Settings.txt",MapSettings)
	Msgbox("Voltooid","Opslaan")
End Sub
Sub Spinner1_ItemClick (Position As Int, Value As Object)
		txtAdres.Text=MapSettings.Get("IP"&(Spinner1.SelectedIndex+1))
		txtPoort.Text=MapSettings.Get("Port"&(Spinner1.SelectedIndex+1))
		txtPass.Text=MapSettings.Get("Pass"&(Spinner1.SelectedIndex+1))

End Sub
Sub cmdDelete_Click
	If Spinner1.SelectedIndex+1 < Spinner1.Size-1 Then
		For i=Spinner1.SelectedIndex+1 To Spinner1.Size-1
			MapSettings.Put("Name"&i,MapSettings.Get("Name"&(i+1)))
			MapSettings.Put("IP"&i,MapSettings.Get("IP"&(i+1)))
			MapSettings.Put("Port"&i,MapSettings.Get("Port"&(i+1)))
			MapSettings.Put("Pass"&i,MapSettings.Get("Pass"&(i+1)))
		Next
	End If
	
	MapSettings.Remove("Name"&(Spinner1.Size))
	MapSettings.Remove("IP"&(Spinner1.Size))
	MapSettings.Remove("Port"&(Spinner1.size))
	MapSettings.Remove("Pass"&(Spinner1.size))
	
	Spinner1.RemoveAt(Spinner1.SelectedIndex)
	
	txtAdres.Text=MapSettings.Get("IP"&(Spinner1.SelectedIndex+1))
	txtPoort.Text=MapSettings.Get("Port"&(Spinner1.SelectedIndex+1))
	txtPass.Text=MapSettings.Get("Pass"&(Spinner1.SelectedIndex+1))
	
	MapSettings.Put("Systems",Spinner1.Size)

	File.WriteMap(File.DirInternal,"Settings.txt",MapSettings)
	
End Sub
Sub ReceiveNext
downloadtimer.Enabled=False
If Groep=0 Then
  DownloadAdres=0x80+((Unit-1)*16)
Else
  DownloadAdres=0x170 + ((Groep-1) * 270) + ((Unit-1) * 17)
End If
Connector.download(DownloadAdres,17)
downloadtimer.Enabled=True
End Sub

Sub downloadtimer_Tick
ReceiveNext
End Sub