﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals

	'Type ButtonTags(Index As Int,Groep As Byte,Unit As Byte,Dimmer As Boolean)
	Private Barname As String
	Private Vpos, H, W,Minv, MaxV, D ,Top2 As Int
	Private Hmodule As Object
	Private Hbase As Panel 
	Private cover As Panel
	Private Knop As Button
	
	Private Delay As Timer

	Private Bulb As ImageView
	Private Icon As ImageView
	Private slider As ImageView
	
	' Properties
	Private Dimmer As Boolean
	
	Public Group As Byte
	Public Unit As Byte
	Public Index As Byte
	

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Module As Object, Eventname As String, left As Int, top As Int, width As Int ,height As Int)
	If Bitmaps.Initialized=False Then Bitmaps.Initialize
	Hmodule = Module
	Barname = Eventname
	H = height
	W = width
	Minv=0
	MaxV=16
	Hbase.Initialize("")
	D = 0.80*H
	Top2=0.10*H
	
	Delay.Initialize("Delay",100)
		
	slider.Initialize("")
	Hbase.AddView(slider,D/2,0+(H/2),W,H/2)
	

	Knop.Initialize("Knop")
	Hbase.AddView(Knop,0,0,W,H)
	Knop.TextSize=20 
	Knop.SetBackgroundImage(Bitmaps.Achtergrond)
	Knop.TextColor=Colors.White
	Knop.Gravity = Bit.Or(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)
	
	cover.Initialize("cover")
	Hbase.AddView(cover,0,0,W-D,H)

	Icon.Initialize("icon")
	Hbase.AddView(Icon,W-(1.2*D),Top2,D,0.6*H)
	Icon.Bitmap=Bitmaps.Draaiknop
	Icon.Gravity=Gravity.FILL
	
	Bulb.Initialize("Bulb")
	Hbase.AddView(Bulb,Top2,Top2,D,D)
	Bulb.Bitmap=Bitmaps.Uit
	Bulb.Gravity=Gravity.FILL
	
End Sub

Private Sub cover_Touch(Action As Int, X As Float, Y As Float) As Boolean 
	Log("cover_Touch")
	Select Case Dimmer
		Case True
			Log("touch dimmer")
			Dim k As Int
			k = X * (MaxV-Minv) / Hbase.Width + Minv
			Vpos = Max(Min(k, MaxV),Minv)
		Case False
			'Log ("touch no dimmer")
			'If Vpos>0 Then Vpos=0 Else Vpos=16
	End Select
	setPosition(Vpos, True)
	Return True
End Sub

Public Sub setVisible(VB As Boolean)
	Hbase.Visible=VB
End Sub

Public Sub getVisible As Boolean
	Return Hbase.Visible
End Sub

Private Sub Delay_Tick
	Delay.Enabled=False
	If SubExists(Hmodule,Barname & "_ValueChangedDelayed") Then
  		CallSub2(Hmodule,Barname & "_ValueChangedDelayed", Vpos)
	End If
End Sub

Public Sub setValue(Value As Int)
	Vpos = Value
	'W = Hbase.Width
	setPosition(Vpos,False)
End Sub

Public Sub getValue As Int
	Return Vpos
End Sub

Public Sub setText(Value As String)
	Knop.Text=Value
End Sub

' Returns the current value of the bar
Public Sub getText As String
	Return Knop.Text
End Sub

Private Sub setPosition(Value As Int, userchanged As Boolean)
	'slider.width = Max(Min(W * (Value-Minv)/(MaxV-Minv), W),0)
	Bulb.left = Max(Min(W-D,slider.width-D/2),0)  
	Hbase.Invalidate
	If SubExists(Hmodule, Barname & "_ValueChanged") Then
  		CallSub3(Hmodule, Barname & "_ValueChanged", Value , userchanged )
	End If
	If Value>0 Then Bulb.Bitmap=Bitmaps.Aan Else Bulb.Bitmap=Bitmaps.Uit
	Delay.Enabled=False
	Delay.Enabled=True
End Sub

Public Sub AsView As View 
	Return Hbase
End Sub

Public Sub setIsDimmer(OnOff As Boolean)
	Dimmer=OnOff
	Icon.Visible=Dimmer
End Sub

Public Sub getIsDimmer As Boolean
	Return Dimmer
End Sub

Sub Knop_Down
	Knop.TextColor=Colors.Cyan
End Sub

Sub Knop_Up
	Knop.TextColor=Colors.White
End Sub

Sub Knop_Click
	If Vpos>0 Then Vpos=0 Else Vpos=16
	setPosition(Vpos,False)
End Sub